;VBXE CORE FX rev. 1.20

VBASE_D640 = $D640
VBASE_D740 = $D740

;Video control
VIDEO_CONTROL = $00
VC = VIDEO_CONTROL

;Video control bits
VC_XDL_ENABLED = 1
VC_XCOLOR = 2
VC_NTR = 4
VC_NO_TRANS = VC_NTR
VC_TRANS15 = 8

; XDL Address
XDL_ADR0 = $01
XDL_ADR1 = $02
XDL_ADR2 = $03
XDL_ADR = XDL_ADR0

; Palette registers
CSEL = $04
PSEL = $05
CR = $06
CG = $07
CB = $08

;Raster collision detection
COLMASK = $09
COLCLR = $0a
COLDETECT = $0a

;XDLC bits
XDLC_TMON = 1
XDLC_GMON = 2
XDLC_OVOFF = 4
XDLC_MAPON = 8
XDLC_MAPOFF = $10
XDLC_RPTL = $20
XDLC_OVADR = $40
XDLC_OVSCRL = $80
XDLC_CHBASE = $100
XDLC_MAPADR = $200
XDLC_MAPPAR = $400
XDLC_OVATT = $800
XDLC_ATT = $800
XDLC_HR = $1000
XDLC_LR = $2000
XDLC_END = $8000

OVW_NARROW = 0
OVW_NORMAL = 1
OVW_WIDE = 2
OVPAL = 4

; MEMAC
MEMAC_B_CONTROL = $1d
MEMB = MEMAC_B_CONTROL
MEMAC_CONTROL = $1e
MEMC = MEMAC_CONTROL
MEMAC_BANK_SEL = $1f
MEMS = MEMAC_BANK_SEL
; MEMAC_CONTROL bits
MCE = 8
MAE = 4
M4K = 0
M8K = 1
M16K = 2
M32K = 3
; MEMAC-A global enable (MEMS register)
MGE = $80
; MEMAC_B_CONTROL bits
MBCE = $80
MBAE = $40
MEMAC_B_WINDOW = $4000
MBANK = $1F

MEMAC_B_WINDOW_SIZE = $4000
MEMAC_B_WINDOW_BEGIN = MEMAC_B_WINDOW
MEMAC_B_WINDOW_END = MEMAC_B_WINDOW+MEMAC_B_WINDOW_SIZE

;Blitter registers
BL_ADR0 = $10
BL_ADR1 = $11
BL_ADR2 = $12
BL_ADR = BL_ADR0
BLITTER_START = $13
BLT_COL_CODE = $10
BLT_COLLISION_CODE = BLT_COL_CODE
BLITTER_BUSY = $13

;Blitter control bits
BL_START=1
BL_STOP=0
BL_BUSY=2
BCB_LOAD=1

;Blitter IRQ
IRQ_CONTROL = $14
IRQ_STATUS = $14

;IRQ_CONTROL bits
IRQE = 1
IRQF = 1

;BCB offsets
BCB_SRCADR = 0
BCB_SRCDY = 3
BCB_SRCDX = 5
BCB_DSTADR = 6
BCB_DSTDY = 9
BCB_DSTDX = 11
BCB_WIDTH = 12
BCB_HEIGHT = 14
BCB_AND = 15
BCB_XOR = 16
BCB_COLL = 17
BCB_ZOOM = 18
BCB_PATT = 19
BCB_CTRL = 20

;BCB bits
BLT_ZOOMX = $0F
BLT_ZOOMY = $F0
IN_USE = $80
PATTERN_WIDTH = $3F
BL_NEXT = 8
NEXT = BL_NEXT
BL_END = 0
MODE = 7
MODE0 = 0
MODE1 = 1
MODE2 = 2
MODE3 = 3
MODE4 = 4
MODE5 = 5
MODE6 = 6
COPYMODE = MODE0
TCOPYMODE = MODE1
ADDMODE = MODE2
ORMODE = MODE3
ANDMODE = MODE4
XORMODE = MODE5
THCOPYMODE = MODE6

;Info registers (read only)
CORE_VERSION = $00
MINOR_REVISION = $01

;Info bits
RAMBO=$80

; VRAM constants
VRAM_SIZE = $80000
VRAM_SIZE_RAMBO = $40000

;Priority registers (ATMAP)
P0 = $15
P1 = $16
P2 = $17
P3 = $18

CORE_RESET = $D080


FX_PROPER_CORE_VERSION = $10
FX_PROPER_MINOR_REVISION = $20

GTIA_PROPER_CORE_VERSION = $11

